@echo off
rem CRYSFIRE - To be copied by CFSETUP to the Windows or DOS directory to act
rem            as launch base for CFMASTER, for running Crysfire 2004, etc.
rem            Now supports both 16-bit and 32-bit versions via %_CFbitmode%
rem            and does its best to work round the limitations of protected
rem            workstations under Windows/XP, etc.
rem
rem            Allocates Q2id suffixes 01-04 for 16/32-bit versions running
rem            under: (01) DOS, Win3.1; (01/02) Win9x; (03/04) WinXP (or NT).
rem
rem R.Shirley, 23Jul04

rem Establish _CFhome directory (hoping that it's on the PATH),
rem first letting it default to C:\Crysfire in case of problems
set _CFhome=C:\CRYSFIRE
call CF_home >nul
%_CFhome%\BWscreen
echo.
echo       **  Crysfire 2004 Interactive Powder-Indexing Support System  **
echo.

if (%_CFhome%) == () goto homeless

%_CFhome%\CFCONFRM
if not exist _Y goto endbat
del _Y >nul

rem Try to get data directory path and plant it via script file _CFWHERE.BAT
rem into environment variable _CFwhere, and hence to _CFdata (obviously this
rem won't work if the current drive/dir is not writeable)
%_CFhome%\WHEREAMI >nul
if not exist _CFWHERE.BAT goto echo_text
call _CFWHERE >nul
del _CFWHERE.BAT
set _CFdata=%_CFwhere%
set _CFwhere=

:echo_text
echo.
echo Launching Crysfire 2004
echo   Home directory = %_CFhome%
if not (%_CFdata%) == () echo   Data directory = %_CFdata%
if (%_CFdata%) == () echo   Data directory couldn't be reported (not writeable?)
echo.
if (%_CFdata%) == () goto unwriteable

rem Detect OS environment and set environment variables for OS version and name:
rem   _16 for 16-bit OS: MSDOS or Win3.1
rem   _9x for 32-bit OS: Win95, 98 or ME
rem   _NT for 32-bit OS: WinXP or other NT-family
rem default is 16-bit
:FindOS_16
set _OS=_16
set _OSname=MSDOS or Win3.1
rem Test for OS=Windows_NT first, since WinXP can also leave winbootdir undefined...
if (%OS%) == (Windows_NT) goto FindOS_NT
rem ...but Win9x should define winbootdir
if (%winbootdir%) == () goto FindOS_cont
:FindOS_9x
set _OS=_9x
set _OSname=Win95, 98 or ME
goto FindOS_cont
:FindOS_NT
set _OS=_NT
set _OSname=WinXP or other NT-family
:FindOS_cont

rem Find whether user wants to run the 16-bit or 32-bit version
if (%_OS%) == (16) goto CFbit_16
:CFbit_32
echo Please choose between the new 32-bit Crysfire (up to 1000 obs lines and
echo 20000 calc lines, currently still in console text mode). or the classic
echo 16-bit version (works under MS-DOS and all versions of MS Windows, but
echo limited to 150 obs lines and 4000 calc lines).
echo Pressing ENTER will select the 32-bit version (default).
echo.
echo Do you want to use the 16-bit version (Y=16bit, N=32bit: default N)?
%_CFhome%\YN
set _CFbitmode=32
if exist _Y set _CFbitmode=16
goto CFbit_cont
:CFbit_16
echo You appear to be running in a 16-bit environment.  If so, you will only be
echo able to run the classic 16-bit Crysfire (works under MS-DOS and all
echo versions of MS Windows, but limited to 150 obs lines and 4000 calc lines)
echo and not the new 32-bit version (up to 1000 obs lines and 20000 calc lines).
echo Please press ENTER to confirm that this is correct (alternatively you can
echo try selecting the 32-bit version, but it may not run in this environment).
echo.
echo Do you want to try the 32-bit version (Y=32bit, N=16bit: default N)?
%_CFhome%\YN
set _CFbitmode=16
if exist _Y set _CFbitmode=32
:CFbit_cont
if exist _Y del _Y >nul

rem Set version suffix for Q2id scripts:
rem   _01 for 16-bit version running under MSDOS, Win3.1 or Win9x
rem   _02 for 32-bit version running under Win9x
rem   _04 for 16-bit version running under WinXP or other NT-family O/S
rem    (_03 if special 16-bit script needed, but so far apparently not)
rem   _04 for 32-bit version running under WinXP or other NT-family O/S 
if (%_OS%) == (_NT) goto OS_NT
:OS_other
if (%_CFbitmode%) == (32) goto OS_9x_32
:OS_9x_16
set _Q2id_ver=_01
goto OS_cont
:OS_9x_32
set _Q2id_ver=_02
goto OS_cont
:OS_NT
if (%_CFbitmode%) == (32) goto OS_NT_32
:OS_NT_16
rem set _Q2id_ver=_03
set _Q2id_ver=_04
goto OS_cont
:OS_NT_32
set _Q2id_ver=_04
:OS_cont

echo.
echo %_CFbitmode%-bit version selected, running under %_OSname% (Q2id_ver=%_Q2id_ver%)
echo.
if not (%_OS%) == (16) goto Report_modes_cont
if not (%_CFbitmode%) == (32) goto Report_modes_cont
echo ** Warning **
echo 32-bit Crysfire may not run in what appears to be a 16-bit environment
echo.
:Report_modes_cont
set _OSname=
pause

rem Launch Crysfire in the chosen bit-mode (passing on any /? or /h parameter).
rem (Don't CALL it, as we won't be coming back unless the launch fails)
rem
%_CFhome%\CFMASTER %1 %2 %3
goto launch_failed

:homeless
echo.
echo ** Failed to establish the path to Crysfire's home directory,
echo    so can't continue launching this Crysfire run
echo.
echo 1) Please ensure that your Crysfire home directory is undamaged
echo.
echo 2) If you have any doubts about the integrity of the files there,
echo    copy the current Crysfire distribution zipfile into that directory
echo    and expand it, to restore all the files to their correct states
echo.
echo 3) If you are happy with (1) and (2):  From that Crysfire home directory,
echo    run CFsetup in order to re-configure Crysfire for your system.  Check
echo    particularly that the correct path to your Crysfire directory has been
echo    specified.  This should be whatever is the correct pathname for the
echo    Crysfire directory on your system (usually C:\CRYSFIRE)
echo.
pause
echo Note that the Crysfire home directory does *not* now need to be on
echo your execution PATH.  In fact it's safer *not* to have it on the PATH,
echo to make it harder to inadvertently pick up an obsolete or corrupt copy
echo of a Crysfire component.  Similarly, it's recommended that all executables
echo (.EXE programs and .BAT scripts) from previous Crysfire distributions
echo should be deleted from your hard disk.  This doesn't of course apply to
echo your own crystallographic data and output files, which will remain valid
echo.
goto endbat

:unwriteable
echo ** Failed to establish the path to the current directory, which will
echo    normally act as the Crysfire data directory.  This probably means
echo    that it can't currently be written to, perhaps because it is (a) on
echo    read-only media, or (b) write-protected, or (c) has no free space, or
echo    (d) has been locked by the operating system as in use by another program.
echo    It can also be reported if one or more required components are not being
echo    picked up from the Crysfire home directory, or have become corrupted.
echo.
echo Since Crysfire will need to be able to write to its data directory,
echo the launch of this Crysfire run can't continue.  Please fix whatever is
echo causing this problem, or move the data to somewhere writeable and try again
echo.
goto endbat

:launch_failed
echo.
echo ** Failed to launch the selected %_CFbitmode%-bit version
echo    so can't continue launching this Crysfire run
echo.
echo 1) Please ensure that your Crysfire home directory is undamaged and that
echo    the file CFMAST%_CFbitmode%.BAT is present in it.
echo.
echo 2) If you have any doubts about the integrity of the files there,
echo    copy the current Crysfire distribution zipfile into that directory
echo    and expand it, to restore all the files to their correct states
echo.
echo 3) If you are happy with (1) and (2):  From that Crysfire home directory,
echo    run CFsetup in order to re-configure Crysfire for your system.  Check
echo    particularly that the correct path to your Crysfire directory has been
echo    specified.  This should be whatever is the correct pathname for the
echo    Crysfire directory on your system (usually C:\CRYSFIRE)
echo.

:endbat
set _Q2id_ver=
set _CFbitmode=
set _OS=
set _CFhome=
set _CFdata=

