@echo off
rem Force a clearscreen to Black on white under WinXP, etc
if (%OS%) == (Windows_NT) %_CFhome%\BWscreen
echo.
rem Q2TR%Q2id_ver% - QDAT/Indexing/post-processor/LePage script (for Crysfire 2002 [TPas])
rem        (includes checks for sort program, linkfile and empty input files)
rem        (Uses _CFhome & CSORT, -Run flag for direct run, XP-compatible)
rem (BWscreen on entry & before ITO & ITlog, to avoid screen overwrites under WinXP, etc)
rem (_Pname not actually used)
set _Pname=TREOR
set _Pver=TREOR90
set _ID=TR
set _Sdate=20Jun04
set _Dsp=S
rem Supported file types: DOSGM (GM via TRLOG v2.1 post-processor)
rem (Typical run time:  under a minute on a 200MHz Pentium)
rem
if (%1) == () goto usage
echo Q2%_ID% - Runs the %_Pver% indexing program automatically on the dataset
echo in targeted QDAT input file %1.Q%_ID% (as written by Crysfire) if present,
echo else in %1.QDT, using QDAT/%_Pver% defaults unless specified otherwise
echo.
echo R.Shirley, %_Sdate%
rem
set _Dspn=short
if (%_Dsp%) == (O) set _Dspn=main
set _Dset=%1

rem _CFhome is now usually set by Crysfire, etc., before this is called
if not (%_CFhome%) == () goto run_test
rem _CFhome hasn't been set ... let's see if we can do it now
call CF_home
if not (%_CFhome%) == () goto run_test
echo ** Q2%_ID% was unable to establish the Crysfire home directory from CF_home.bat
echo (Please check that there's a valid copy of CF_home.bat on the execution path)
echo.
goto end

:run_test
if (%2) == (-Run) goto d_chkdata

:q_chkdata
rem Use 1) %_Dset%.Q%_ID% if present, else 2) %_Dset%.QDT
if exist %_Dset%.Q%_ID% copy %_Dset%.Q%_ID% QDAT.DAT >nul
%_CFhome%\DelifNul %_Dset%.Q%_ID%
if exist %_Dset%.Q%_ID% goto proceed
if exist %_Dset%.QDT copy %_Dset%.QDT QDAT.DAT >nul
%_CFhome%\DelifNul %_Dset%.QDT
if exist %_Dset%.QDT goto proceed
echo.
echo ** Valid input file %1.Q%_ID% (or %1.QDT) not found in this directory
echo ** Cannot proceed with the run - check for mis-typing, etc
echo.
goto end

:d_chkdata
rem Use 1) %_Dset%.%_ID%D if present, else 2) %_Dset%.DAT (copied to .%_ID%D)
%_CFhome%\DelifNul %_Dset%.%_ID%D
if exist %_Dset%.%_ID%D goto proceed
%_CFhome%\DelifNul %_Dset%.DAT
if exist %_Dset%.DAT copy %_Dset%.DAT %_Dset%.%_ID%D >nul
if exist %_Dset%.%_ID%D goto proceed
echo.
echo ** Valid input file %1.%_ID%D (or %1.DAT) not found in this directory
echo ** Cannot proceed with the direct run - check for mis-typing, etc
echo.
goto end

:proceed

:SetIndexEdit
if not (%INDEXEDIT%) == () goto IndexEditSet
rem Try to sense whether we're running on W95, and if so set default output
rem viewer to WordPad (i.e. "Write") instead of MS EDIT.  (Done here as well
rem as in Crysfire.bat, in case this is run directly)
if not (%winbootdir%) == () set INDEXEDIT=Write
if %COMSPEC% == C:\WINDOWS\COMMAND.COM set INDEXEDIT=Write
:IndexEditSet
if (%2) == (-Run) goto drun_entry

echo.
echo.
echo Running QDAT format conversion program to generate %_Pver% input data file ...
echo.
%_CFhome%\QDAT
del QDAT.DAT
copy QDAT.OUT %_Dset%.QDO >nul
del QDAT.OUT
:chk_cards
%_CFhome%\DelifNul CARDS.OUT
if exist CARDS.OUT goto copy_cards
echo.
echo    ** Can't find a valid QDAT output file (CARDS.OUT) from this run
goto failed
:copy_cards
copy CARDS.OUT %_Dset%.%_ID%D >nul
del CARDS.OUT >nul

:drun_entry
rem Rename any existing %_Dset%.%_ID%O main output file to %_ID%_OUT.BAK, so
rem as not to confuse it with the output from this run, in case this run fails
if exist %_ID%_OUT.BAK del %_ID%_OUT.BAK >nul
if exist %_Dset%.%_ID%O ren %_Dset%.%_ID%O %_ID%_OUT.BAK >nul
rem Similarly rename any existing %_Dset%.%_ID%S short output file
if exist %_ID%_SHT.BAK del %_ID%_SHT.BAK >nul
if exist %_Dset%.%_ID%S ren %_Dset%.%_ID%S %_ID%_SHT.BAK >nul
rem *** TREOR90-specific
echo %_Dset%.%_ID%D >  %_Pver%.PAR
echo %_Dset%.%_ID%O >> %_Pver%.PAR
echo %_Dset%.%_ID%S >> %_Pver%.PAR
echo.       >> %_Pver%.PAR
echo.
echo Running %_Pver% indexing program from steering file ...
echo.
rem TREOR90 doesn't produce any screen output, so no worries about it over-writing existing output
%_CFhome%\%_Pver% <%_Pver%.PAR >nul
del %_Pver%.PAR

rem Since %_Pver% doesn't support log/summary files,
rem we must generate them with the %_ID%LOG post-processor,
rem communicating with CFMAIN via a linkfile which we'll now create...
if exist %_Dset%.%_ID%_ del %_Dset%.%_ID%_ >nul
if exist %_ID%LOG.LNK del %_ID%LOG.LNK >nul
%_CFhome%\CFMAIN -Link %_Dset% %_ID%
rem That seems to make WinXP's cmd.exe lose its place, so let's reset thngs with BWscreen
%_CFhome%\\BWscreen
rem ...then run the post-processor
%_CFhome%\%_ID%LOG %_Dset%
if exist %_Dset%.%_ID%_ del %_Dset%.%_ID%_ >nul
if exist %_ID%LOG.LNK goto del_itlnk
echo.
echo    ** Linkage exception encountered - obsolete/missing %_ID%LOG post-processor?
goto failed
:del_itlnk
if exist %_ID%LOG.LNK del %_ID%LOG.LNK >nul
goto chk_out
rem Re systematic file renaming
rem %_ID%LOG writes .%_ID%G &.%_ID%M files directly, so ren_log & ren_sum aren't needed
rem and %_Pver% writes .%_ID%O & .%_ID%S, so ren_sht & ren_out aren't needed either

:chk_out
%_CFhome%\DelifNul %_Dset%.%_ID%O
if exist %_Dset%.%_ID%O goto upd_log
rem Restore old main & short output files from backup before taking error exit
rem ***
if exist %_ID%_OUT.BAK ren %_ID%_OUT.BAK %_Dset%.%_ID%O
:rest_sbak
rem if exist %_Dset%.%_ID%S goto fail_out
rem if exist %_ID%_SHT.BAK ren %_ID%_SHT.BAK %_Dset%.%_ID%S
:fail_out
echo.
echo    ** Can't find the main output file %_Dset%.%_ID%O from this run
goto failed
rem *** TREOR90-specific omission of ren_out
rem ***

:upd_log
rem Append run-logfile .%_ID%G to dataset-logfile .LOG (leaving backup in .LGK)
%_CFhome%\DelifNul %_Dset%.%_ID%G
if not exist %_Dset%.%_ID%G goto upd_app
if exist %_Dset%.LGK del %_Dset%.LGK >nul
if exist %_Dset%.LOG ren %_Dset%.LOG %_Dset%.LGK
if exist %_Dset%.LGK copy %_Dset%.LGK+%_Dset%.%_ID%G %_Dset%.LOG >nul
if not exist %_Dset%.LGK copy %_Dset%.%_ID%G %_Dset%.LOG >nul

:upd_app
rem Append run-summary .%_ID%M to dataset-summary .SUM (leaving backup in .SMK),
rem sort the updated dataset-summary into descending order of I20 & Merit
rem and update the V/V1 ratios based on the volume now in record one
%_CFhome%\DelifNul %_Dset%.%_ID%M
if not exist %_Dset%.%_ID%M goto disp_sht
if exist %_Dset%.SMK del %_Dset%.SMK >nul
if exist %_Dset%.SUM ren %_Dset%.SUM %_Dset%.SMK
if exist %_Dset%.SMK copy %_Dset%.SMK+%_Dset%.%_ID%M %_Dset%.$$1 >nul
if not exist %_Dset%.SMK copy %_Dset%.%_ID%M %_Dset%.$$1 >nul
%_CFhome%\DelifNul %_Dset%.$$1
if not exist %_Dset%.$$1 goto add_head

:chk_sort
%_CFhome%\DelifNul %_Dset%.%_ID%M
if not exist %_Dset%.%_ID%M goto disp_sht
rem Skip if already verified and prepared the sort utility...
if not (%_Csrtst%) == () goto run_VRAT
rem ...else establish which sort program to use

rem But, for robustness, simply specify CSORT rather than test for a sort program
set _Csrt=%_CFhome%\CSORT -r
set _Csrtst=Yes
goto run_VRAT

echo.
echo Checking that there's a working SORT program on the execution PATH
echo.
set _Csrt=
if exist _Csrtb del _Csrtb
echo abc > _Csrta
rem Try MS SORT
SORT /R <_Csrta >_Csrtb
if exist _Csrtb set _Csrt=SORT /R
rem Also need to make a _Csrtst var, since Win/XP doesn't allow
rem spaces in the test strings used for "if ... = ..." tests
if exist _Csrtb set _Csrtst=Yes
if not (%_Csrtst%) == () goto run_VRAT
rem Nope, so try CSORT
rem CSORT parameter must be "-r" and not "-R", or usage will also be displayed
%_CFhome%\CSORT -r <_Csrta >_Csrtb
if exist _Csrtb set _Csrt=%_CFhome%\CSORT -r
if exist _Csrtb set _Csrtst=Yes
rem if not (%_Csrtst%) == () goto run_VRAT
if exist _Csrta del _Csrta
if exist _Csrtb del _Csrtb
echo  ** Warning **  Crysfire has not found a working SORT program on this system.
echo.
echo  If you proceed, you will still be able to run Crysfire commands and launch
echo  indexing runs, but Crysfire will be unable to display any sorted summary files
echo  or run the LePage program to produce a revised summary of the reduced cells
echo.
echo  To exit, press ENTER, then type QU (and ENTER) at the Crysfire command prompt
echo.
echo  This shouldn't be able to happen if Crysfire has been installed correctly,
echo  since the Crysfire 2002 distribution includes a sort utility CSORT.
echo  Check that CSORT.EXE has been copied correctly to your Crysfire directory
echo.
pause

:run_VRAT
if exist _Csrta del _Csrta
if exist _Csrtb del _Csrtb
if not (%_Csrtst%) == () %_Csrt% <%_Dset%.$$1 >%_Dset%.$$2
rem Use program VRATIO to update the V/V1 ratios in the sorted summary
%_CFhome%\DelifNul %_Dset%.$$2
if not exist %_Dset%.$$2 goto add_head
%_CFhome%\VRATIO %_Dset%.$$2 %_Dset%.SUM >nul
del %_Dset%.$$? >nul
:add_head
if exist %_Dset%.SMH del %_Dset%.SMH >nul
rem Use program QHEAD to generate headings file HEADINGS.SUM, so that
rem HEADINGS.SUM need not be copied beforehand into the current directory
%_CFhome%\QHEAD >nul
rem HEADINGS.SUM should now be present, but its existence tests have been
rem kept anyway, in case of problems
if exist HEADINGS.SUM copy HEADINGS.SUM+%_Dset%.SUM %_Dset%.SMH >nul

:disp_sht
%_CFhome%\DelifNul %_Dset%.%_ID%M
if exist %_Dset%.%_ID%M echo Run completed
if not exist %_Dset%.%_ID%M echo Can't find a summary file so it seems that the run found no solutions
if (%INDEXEDIT%) == (NONE) goto end
echo.
echo The %_Dspn% output file will now be displayed in an editor.
if (%_Csrtst%) == () goto cont_sht
if not exist %_Dset%.%_ID%M goto cont_sht
echo.
echo This will be followed by an updated summary of all solutions so far
echo for this dataset, then by a Le Page reduced-cell analysis.
echo.
:cont_sht
pause
set INDXED=%INDEXEDIT%
if (%INDXED%) == () set INDXED=edit
%INDXED% %_Dset%.%_ID%%_Dsp%
%_CFhome%\DelifNul %_Dset%.%_ID%M
if exist %_Dset%.%_ID%M goto if_sort
echo ** No summary files to display, so this analysis can't be taken further
echo.
pause
goto end

:if_sort
if not (%_Csrtst%) == () goto cont_smh
echo.
echo ** Can't proceed to display sorted summary files, etc., without a
echo ** working sort program, so must terminate this analysis here
echo.
pause
goto end

:cont_smh
%_CFhome%\DelifNul %_Dset%.SMH
if exist %_Dset%.SMH goto disp_smh
if exist HEADINGS.SUM goto disp_cont
echo Don't interrupt the run to do it now, but note for future reference that
echo if you make sure that the program QHEAD is present in the Crysfire directory,
echo your summary files will then be displayed with an explanatory heading.
echo.
pause
:disp_cont
%_CFhome%\DelifNul %_Dset%.SUM
if exist %_Dset%.SUM goto disp_smh
echo Can't find summary file %_Dset%.SMH or .SUM to display next in the editor,
echo so will have to end the run now, and leave you to check that for yourself
goto end

:disp_smh
rem We can now delete HEADINGS.SUM to reduce the file clutter (it was retained
rem only as a flag to disarm the above QHEAD warning, if present)
if exist HEADINGS.SUM del HEADINGS.SUM >nul
echo The sorted summary file of all indexing solutions found so far by the
echo Crysfire system for dataset %_Dset% will now be displayed.
echo.
pause
set _EXT=SUM
if exist %_Dset%.SMH set _EXT=SMH
%INDXED% %_Dset%.%_EXT%
set _EXT=

%_CFhome%\DelifNul %_Dset%.SUM
if exist %_Dset%.SUM goto run_clp
:runclp_err
echo Can't find summary file %_Dset%.SUM, so can't do a Le Page reduced-cell
echo analysis - must terminate these analyses and return to the main Crysfire prompt
echo.
pause
goto end

:run_clp
echo An adapted version of Ton Spek's LEPAGE reduced-cell program will now run
echo (with acknowledgements to Ton Spek [Utrecht] and A. Meetsma [Groningen]).
echo This will process each solution in the summary file, giving its Le Page
echo reduced cell, a proposed conventional cell and additional items of lattice
echo and symmetry information.
echo.
echo Its main output file will be written to disk and will include the Niggli
echo reduced cell for each solution, with its corresponding sub-cell and
echo super-cell analyses.  This is not displayed automatically as it can be
echo bulky and requires experience to interpret - if not required, consider
echo saving disk space by deleting it after quitting Crysfire, and perhaps
echo later using the LePage function in Laugier & Bocchu's Chekcell program.
echo.
echo Instead a revised summary file will be displayed, listing the various
echo solutions with their reduced cell properties.
echo.
if exist %_Dset%.COK del %_Dset%.COK
if exist %_Dset%.CLO ren %_Dset%.CLO %_Dset%.COK
if exist %_Dset%.CMK del %_Dset%.CMK
if exist %_Dset%.CLM ren %_Dset%.CLM %_Dset%.CMK
%_CFhome%\CLEPAGE %_Dset% AUTO >nul
%_CFhome%\DelifNul %_Dset%.CLO
rem As %_Dset%.CLO is no longer displayed, it's not worth checking for it
rem if exist %_Dset%.CLO goto disp_clo
goto chk_clm

:dspclo_err
rem dspclo_err can't now be reached - R.Shirley, 16May02
echo Can't find Le Page output file %_Dset%.CLO, so will have to terminate
echo these analyses now, and return to the main Crysfire prompt
echo.
pause
goto end

:disp_clo
rem Main Le Page output file no longer displayed (too bulky and confusing)
rem so the next 3 lines have been commented out - R.Shirley, 23Apr02
rem echo The Le Page %_Dspn% output file will now be displayed.
rem echo.
rem pause
rem %INDXED% %_Dset%.CLO

:chk_clm
%_CFhome%\DelifNul %_Dset%.CLM
if exist %_Dset%.CLM goto disp_clm
:dspclm_err
echo Can't find Le Page summary file %_Dset%.CLM to display next in the editor,
echo so will have to end the run now, and leave you to check that for yourself
goto end

:disp_clm
echo The Le Page summary file will now be displayed.
echo.
pause
%INDXED% %_Dset%.CLM
goto end

:failed
call %_CFhome%\FailText
goto end

:usage
echo Q2%_ID%%Q2id_ver% - Runs the %_Pver% indexing program automatically on the dataset
echo in targeted QDAT input file %%1.Q%_ID% (as written by Crysfire) if present,
echo else in %%1.QDT, using QDAT/%_Pver% defaults unless specified otherwise
echo (or a direct indexing run that by-passes QDAT if %%2 = -Run)
rem *** TREOR90-specific
echo Typical run time:  under a minute on a 200MHz Pentium
rem ***
echo.
echo usage    Q2%_ID%%Q2id_ver% {datafile} {run_flag}
echo.
echo          where %1 {datafile} is the base name of the %%1.Q%_ID% targeted
echo                   QDAT input file (or %%1.QDT QDAT input file)
echo                   (without its .Q%_ID% or .QDT extension)
echo                   (.%_ID%D or .DAT extension if this is to be a direct run)
echo.
echo                %2 {run_flag} is the optional flag "-Run" to indicate that
echo                    this is to be a direct run, by-passing QDAT
echo.
pause
echo   The same {datafile} name is used to identify all files in the run:
echo.
echo      QDAT targeted input file   = {datafile}.Q%_ID%
echo        or QDAT input file       = {datafile}.QDT
echo      QDAT output listing file   = {datafile}.QDO
echo      %_Pver% input data file    = {datafile}.%_ID%D
echo      %_Pver% main output file   = {datafile}.%_ID%O
echo      %_Pver% short output file  = {datafile}.%_ID%S
rem *** TREOR90-specific
rem echo      %_Pver% input verification   = {datafile}.%_ID%V
rem ***
echo      %_Pver% solutions-log      = {datafile}.%_ID%G
echo      %_Pver% solutions-summary  = {datafile}.%_ID%M
echo.
pause
echo   The solutions log and summary are also appended to the log and summary
echo   files for that dataset: {datafile}.LOG and {datafile}.SUM respectively.
echo   {datafile}.SUM is then sorted into descending order of I20 and Merit.
echo   (The minimum levels for inclusion vary for different indexing programs,
echo   but are typically I20 above 15 and Merit above approx 7 to 9)
echo.
echo   At the end of the indexing run, first the short output file, and then
echo   the sorted solutions summary, are displayed using the editor specified
echo   in environmental variable INDEXEDIT (default: WordPad[Windows],EDIT[DOS]).
echo.
echo   A Le Page reduced-cell analysis is then performed on all solutions found
echo   so far (taken in descending order as described above), courtesy of
echo   Ton Spek and A.Meetsma, and a revised summary file displayed including
echo   reduced cell information.  Since the main Le Page output file can be bulky
echo   and rather technical, it is saved to disk without being displayed.
echo.
pause
echo   Thus the following files provide a record of all runs for this dataset,
echo   after updating with the current run as described above:
echo.
echo      dataset solutions-log         = {datafile}.LOG
echo      dataset solutions-summary     = {datafile}.SUM  (sorted)
echo      dataset solutions-display     = {datafile}.SMH  (headed summary)
echo      Le Page reduced-cell analysis = {datafile}.CLO  (in sorted order)
echo      Le Page reduced-cell summary  = {datafile}.CLM  (headed summary)
echo.
echo      old dataset solutions-log     = {datafile}.LGK  (backup)
echo      old dataset solutions-summary = {datafile}.SMK  (backup)
echo      old Le Page analysis          = {datafile}.COK  (backup)
echo      old Le Page summary           = {datafile}.CMK  (backup)
echo.
echo   R.Shirley, %_Sdate%
echo.

:end
set INDXED=
set _Dset=
set _Dspn=
set _Dsp=
set _Sdate=
set _ID=
set _Pver=
set _Pname=
